<?php

namespace Drupal\pattern_library\Plugin;

/**
 * Pattern modifier type interface.
 */
interface PatternModifierTypeInterface {

  /**
   * Pattern modifier render element.
   *
   * @return array
   *   A modifier element render array.
   */
  public function render();

  /**
   * Define the cast value.
   *
   * @param $value
   *   The raw value input.
   *
   * @return mixed
   *   The casted value.
   */
  public static function castValue($value);

  /**
   * Define the transform value.
   *
   * @param $value
   *   The casted value.
   *
   * @return mixed
   *   The transformed value.
   */
  public static function transformValue($value);
}
