<?php

namespace Drupal\pattern_library\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

/**
 * Define the valid pattern library region validator.
 */
class ValidPatternLibraryModifierValidator extends ConstraintValidator {

  /**
   * {@inheritDoc}
   */
  public function validate($items, Constraint $constraint) {
    if (!is_array($items)) {
      $this->context->addViolation(
        'Modifiers are required to be an associative array.'
      );
    }

    foreach ($items as $region => $modifier) {
      if (!isset($modifier['type'])) {
        $this->context->addViolation($constraint->modifierPropertyRequired,
          ['%region' => $region, '%property' => 'type']
        );
      }
    }
  }
}
