<?php

namespace Drupal\pattern_library\TypedData;

use Drupal\Core\TypedData\DataDefinition;
use Drupal\Core\TypedData\MapDataDefinition;

/**
 * Define pattern library definition.
 */
class PatternLibraryDefinition extends MapDataDefinition {

  /**
   * {@inheritdoc}
   */
  public function getPropertyDefinitions() {
    if (!isset($this->propertyDefinitions)) {
      $this->propertyDefinitions['label'] = DataDefinition::create('string')
        ->setLabel('Label')
        ->setRequired(TRUE);
      $this->propertyDefinitions['source'] = DataDefinition::create('string')
        ->setLabel('Source')
        ->setRequired(TRUE);
      $this->propertyDefinitions['icon'] = DataDefinition::create('string')
        ->setLabel('Icon Path')
        ->setRequired(FALSE);
      $this->propertyDefinitions['icon_map'] = MapDataDefinition::create()
        ->setLabel('Icon Map')
        ->setRequired(FALSE);
      $this->propertyDefinitions['styles'] = MapDataDefinition::create()
        ->setLabel('Styles')
        ->setRequired(FALSE);
      $this->propertyDefinitions['libraries'] = MapDataDefinition::create()
        ->setLabel('Libraries')
        ->setRequired(FALSE);
      $this->propertyDefinitions['provider'] = DataDefinition::create('string')
        ->setLabel('Provider')
        ->setRequired(TRUE);
      $this->propertyDefinitions['regions'] = MapDataDefinition::create()
        ->setLabel('Regions')
        ->setRequired(TRUE);
      $this->propertyDefinitions['modifiers'] = MapDataDefinition::create()
        ->setLabel('Modifiers')
        ->setConstraints([
          'ValidPatternLibraryModifier' => []
        ])
        ->setRequired(FALSE);;
    }

    return $this->propertyDefinitions;
  }
}
